const babel = require("@babel/core");

function babelPluginChangeImport({ types: t }) {
  return {
    visitor: {
      ImportDeclaration(path, state) {
        let { modulePath, libraryName, names } = state.opts;
        let { node } = path;
        let specs = [];

        if (node.source.value === libraryName) {
          node.specifiers.forEach((spec) => {
            if (t.isImportSpecifier(spec)) {
              specs.push(spec);
            }
          });

          const imports = specs.map((spec) => {
            if (spec?.imported?.name in names) {
              return `import ${spec?.local.name} from '${
                names[spec?.imported?.name]
              }/${spec?.imported?.name}'`;
            }

            return `import ${spec?.local?.name} from '${modulePath}/${spec?.imported?.name}'`;
          });

          path.replaceWith(babel.parse(imports.join("\n")).program);
        }
      },
    },
  };
}

module.exports = babelPluginChangeImport;
